# SdFat: SdStreamBase Class Reference

SdStreamBase Class Reference

Base class for SD streams. More...

`#include <SdStream.h>`

Inheritance diagram for SdStreamBase:
[legend]
Collaboration diagram for SdStreamBase:
[legend]

## Public Types

typedef unsigned int | fmtflags
typedef unsigned char | iostate
typedef int32_t | off_type
typedef uint8_t | openmode
typedef uint32_t | pos_type
enum | seekdir { beg, cur, end }
typedef uint32_t | streamsize

## Public Member Functions

bool | bad () const
void | clear (iostate state=goodbit)
bool | eof () const
bool | fail () const
char | fill ()
char | fill (char c)
fmtflags | flags () const
fmtflags | flags (fmtflags fl)
bool | good () const
| operator const void * () const
bool | operator! () const
int | precision () const
int | precision (unsigned int n)
iostate | rdstate () const
fmtflags | setf (fmtflags fl)
fmtflags | setf (fmtflags fl, fmtflags mask)
void | setstate (iostate state)
void | unsetf (fmtflags fl)
unsigned | width ()
unsigned | width (unsigned n)

## Static Public Attributes

static const fmtflags | adjustfield = left | right | internal
static const openmode | app = 0X4
static const openmode | ate = 0X8
static const iostate | badbit = 0X01
static const fmtflags | basefield = dec | hex | oct
static const openmode | binary = 0X10
static const fmtflags | boolalpha = 0x0100
static const fmtflags | dec = 0x0008
static const iostate | eofbit = 0x02
static const iostate | failbit = 0X04
static const iostate | goodbit = 0x00
static const fmtflags | hex = 0x0010
static const openmode | in = 0X20
static const fmtflags | internal = 0x0004
static const fmtflags | left = 0x0001
static const fmtflags | oct = 0x0020
static const openmode | out = 0X40
static const fmtflags | right = 0x0002
static const fmtflags | showbase = 0x0200
static const fmtflags | showpoint = 0x0400
static const fmtflags | showpos = 0x0800
static const fmtflags | skipws = 0x1000
static const openmode | trunc = 0X80
static const fmtflags | uppercase = 0x4000

## Protected Member Functions

uint32_t | available ()
void | clearWriteError ()
bool | close ()
bool | contiguousRange (uint32_t *bgnBlock, uint32_t *endBlock)
bool | createContiguous (SdBaseFile *dirFile, const char *path, uint32_t size)
uint32_t | curCluster () const
uint32_t | curPosition () const
bool | dirEntry (dir_t *dir)
bool | exists (const char *name)
int16_t | fgets (char *str, int16_t num, char *delim=0)
uint32_t | fileSize () const
uint32_t | firstCluster () const
uint8_t | flagsToBase ()
bool | getFilename (char *name)
void | getpos (FatPos_t *pos)
bool | getWriteError ()
bool | isDir () const
bool | isFile () const
bool | isOpen () const
bool | isRoot () const
bool | isSubDir () const
void | ls (Print *pr, uint8_t flags=0, uint8_t indent=0)
void | ls (uint8_t flags=0)
bool | mkdir (SdBaseFile *dir, const char *path, bool pFlag=true)
bool | open (SdBaseFile *dirFile, uint16_t index, uint8_t oflag)
bool | open (SdBaseFile *dirFile, const char *path, uint8_t oflag)
bool | open (const char *path, uint8_t oflag=O_READ)
bool | openNext (SdBaseFile *dirFile, uint8_t oflag)
bool | openRoot (SdVolume *vol)
int | peek ()
bool | printCreateDateTime (Print *pr)
int | printField (float value, char term, uint8_t prec=2)
int | printField (int16_t value, char term)
int | printField (uint16_t value, char term)
int | printField (int32_t value, char term)
int | printField (uint32_t value, char term)
size_t | printFileSize (Print *pr)
bool | printModifyDateTime (Print *pr)
size_t | printName ()
size_t | printName (Print *pr)
int16_t | read ()
int | read (void *buf, size_t nbyte)
int8_t | readDir (dir_t *dir)
bool | remove ()
bool | rename (SdBaseFile *dirFile, const char *newPath)
void | rewind ()
bool | rmdir ()
bool | rmRfStar ()
bool | seekCur (int32_t offset)
bool | seekEnd (int32_t offset=0)
bool | seekSet (uint32_t pos)
void | setpos (FatPos_t *pos)
bool | sync ()
bool | timestamp (SdBaseFile *file)
bool | timestamp (uint8_t flag, uint16_t year, uint8_t month, uint8_t day, uint8_t hour, uint8_t minute, uint8_t second)
bool | truncate (uint32_t size)
uint8_t | type () const
SdVolume * | volume () const
int | write (const void *buf, size_t nbyte)

## Static Protected Member Functions

static SdBaseFile * | cwd ()
static void | dateTimeCallback (void(*dateTime)(uint16_t *date, uint16_t *time))
static void | dateTimeCallbackCancel ()
static void | dirName (const dir_t &dir, char *name)
static void | printFatDate (uint16_t fatDate)
static void | printFatDate (Print *pr, uint16_t fatDate)
static void | printFatTime (uint16_t fatTime)
static void | printFatTime (Print *pr, uint16_t fatTime)
static bool | remove (SdBaseFile *dirFile, const char *path)

## Protected Attributes

bool | writeError

## Detailed Description

Base class for SD streams.

## Member Typedef Documentation

typedef unsigned int ios_base::fmtflags

inherited

type for format flags

typedef unsigned char ios_base::iostate

inherited

typedef for iostate bitmask

typedef int32_t ios_base::off_type

inherited

type for relative seek offset

typedef uint8_t ios_base::openmode

inherited

typedef for iostream open mode

typedef uint32_t ios_base::pos_type

inherited

type for absolute seek position

typedef uint32_t ios_base::streamsize

inherited

unsigned size that can represent maximum file size. (violates spec - should be signed)

## Member Enumeration Documentation

enum ios_base::seekdir

inherited

enumerated type for the direction of relative seeks

Enumerator
beg | seek relative to the beginning of the stream
cur | seek relative to the current stream position
end | seek relative to the end of the stream

## Member Function Documentation

uint32_t SdBaseFile::available | ( |  | ) |

inlineinherited

Returns
  number of bytes available from yhe current position to EOF

bool ios::bad | ( |  | ) | const

inlineinherited

Returns
  true if bad bit is set else false.

void ios::clear | ( | iostate | state = `goodbit` | ) |

inlineinherited

Clear iostate bits.

Parameters

  [in] | state | The flags you want to set after clearing all flags.

void SdBaseFile::clearWriteError | ( |  | ) |

inlineinherited

Set writeError to zero

bool SdBaseFile::close | ( |  | ) |

inherited

Close a file and force cached data and directory information to be written to the storage device.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include no file is open or an I/O error.

bool SdBaseFile::contiguousRange | ( | uint32_t * | bgnBlock,
|  | uint32_t * | endBlock
| ) |  |

inherited

Check for contiguous file and return its raw block range.

Parameters

  [out] | bgnBlock | the first block address for the file.
  [out] | endBlock | the last block address for the file.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include file is not contiguous, file has zero length or an I/O error occurred.

bool SdBaseFile::createContiguous | ( | SdBaseFile * | dirFile,
|  | const char * | path,
|  | uint32_t | size
| ) |  |

inherited

Create and open a new contiguous file of a specified size.

Note
  This function only supports short DOS 8.3 names. See open() for more information.

Parameters

  [in] | dirFile | The directory where the file will be created.
  [in] | path | A path with a valid DOS 8.3 file name.
  [in] | size | The desired file size.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include path contains an invalid DOS 8.3 file name, the FAT volume has not been initialized, a file is already open, the file already exists, the root directory is full or an I/O error.

uint32_t SdBaseFile::curCluster | ( |  | ) | const

inlineinherited

Returns
  The current cluster number for a file or directory.

uint32_t SdBaseFile::curPosition | ( |  | ) | const

inlineinherited

Returns
  The current position for a file or directory.

static SdBaseFile* SdBaseFile::cwd | ( |  | ) |

inlinestaticinherited

Returns
  Current working directory

static void SdBaseFile::dateTimeCallback | ( | void(*)(uint16_t *date, uint16_t *time) | dateTime | ) |

inlinestaticinherited

Set the date/time callback function

Parameters

  [in] | dateTime | The user's call back function. The callback function is of the form:

void dateTime(uint16_t* date, uint16_t* time) {
uint16_t year;
uint8_t month, day, hour, minute, second;
// User gets date and time from GPS or real-time clock here
// return date using FAT_DATE macro to format fields
*date = FAT_DATE(year, month, day);
// return time using FAT_TIME macro to format fields
*time = FAT_TIME(hour, minute, second);
}

Sets the function that is called when a file is created or when a file's directory entry is modified by sync(). All timestamps, access, creation, and modify, are set when a file is created. sync() maintains the last access date and last modify date/time.

See the timestamp() function.

static void SdBaseFile::dateTimeCallbackCancel | ( |  | ) |

inlinestaticinherited

Cancel the date/time callback function.

bool SdBaseFile::dirEntry | ( | dir_t * | dir | ) |

inherited

Return a file's directory entry.

Parameters

  [out] | dir | Location for return of the file's directory entry.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

void SdBaseFile::dirName | ( | const dir_t & | dir,
|  | char * | name
| ) |  |

staticinherited

Format the name field of dir into the 13 byte array name in standard 8.3 short name format.

Parameters

  [in] | dir | The directory structure containing the name.
  [out] | name | A 13 byte char array for the formatted name.

bool ios::eof | ( |  | ) | const

inlineinherited

Returns
  true if end of file has been reached else false.

Warning: An empty file returns false before the first read.

Moral: eof() is only useful in combination with fail(), to find out whether EOF was the cause for failure

bool SdBaseFile::exists | ( | const char * | name | ) |

inherited

Test for the existence of a file in a directory

Parameters

  [in] | name | Name of the file to be tested for.

The calling instance must be an open directory file.

dirFile.exists("TOFIND.TXT") searches for "TOFIND.TXT" in the directory dirFile.

Returns
  true if the file exists else false.

bool ios::fail | ( |  | ) | const

inlineinherited

Returns
  true if any iostate bit other than eof are set else false.

int16_t SdBaseFile::fgets | ( | char * | str,
|  | int16_t | num,
|  | char * | delim = `0`
| ) |  |

inherited

Get a string from a file.

fgets() reads bytes from a file into the array pointed to by str, until num - 1 bytes are read, or a delimiter is read and transferred to str, or end-of-file is encountered. The string is then terminated with a null byte.

fgets() deletes CR, '\r', from the string. This insures only a '\n' terminates the string for Windows text files which use CRLF for newline.

Parameters

  [out] | str | Pointer to the array where the string is stored.
  [in] | num | Maximum number of characters to be read (including the final null byte). Usually the length of the array str is used.
  [in] | delim | Optional set of delimiters. The default is "\n".

Returns
  For success fgets() returns the length of the string in str. If no data is read, fgets() returns zero for EOF or -1 if an error occurred.

uint32_t SdBaseFile::fileSize | ( |  | ) | const

inlineinherited

Returns
  The total number of bytes in a file or directory.

char ios_base::fill | ( |  | ) |

inlineinherited

Returns
  fill character

char ios_base::fill | ( | char | c | ) |

inlineinherited

Set fill character

Parameters

  [in] | c | new fill character

Returns
  old fill character

uint32_t SdBaseFile::firstCluster | ( |  | ) | const

inlineinherited

Returns
  The first cluster number for a file or directory.

fmtflags ios_base::flags | ( |  | ) | const

inlineinherited

Returns
  format flags

fmtflags ios_base::flags | ( | fmtflags | fl | ) |

inlineinherited

set format flags

Parameters

  [in] | fl | new flag

Returns
  old flags

uint8_t ios_base::flagsToBase | ( |  | ) |

inlineprotectedinherited

Returns
  current number base

bool SdBaseFile::getFilename | ( | char * | name | ) |

inherited

Get a file's name

Parameters

  [out] | name | An array of 13 characters for the file's name.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

void SdBaseFile::getpos | ( | FatPos_t * | pos | ) |

inherited

get position for streams

Parameters

  [out] | pos | struct to receive position

bool SdBaseFile::getWriteError | ( |  | ) |

inlineinherited

Returns
  value of writeError

bool ios::good | ( |  | ) | const

inlineinherited

Returns
  True if no iostate flags are set else false.

bool SdBaseFile::isDir | ( |  | ) | const

inlineinherited

Returns
  True if this is a directory else false.

bool SdBaseFile::isFile | ( |  | ) | const

inlineinherited

Returns
  True if this is a normal file else false.

bool SdBaseFile::isOpen | ( |  | ) | const

inlineinherited

Returns
  True if this is an open file/directory else false.

bool SdBaseFile::isRoot | ( |  | ) | const

inlineinherited

Returns
  True if this is the root directory.

bool SdBaseFile::isSubDir | ( |  | ) | const

inlineinherited

Returns
  True if this is a subdirectory else false.

void SdBaseFile::ls | ( | Print * | pr,
|  | uint8_t | flags = `0`,
|  | uint8_t | indent = `0`
| ) |  |

inherited

List directory contents.

Parameters

  [in] | pr | Print stream for list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Parameters

  [in] | indent | Amount of space before file name. Used for recursive list to indicate subdirectory level.

void SdBaseFile::ls | ( | uint8_t | flags = `0` | ) |

inherited

List directory contents to stdOut.

Parameters

  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

bool SdBaseFile::mkdir | ( | SdBaseFile * | parent,
|  | const char * | path,
|  | bool | pFlag = `true`
| ) |  |

inherited

Make a new directory.

Parameters

  [in] | parent | An open SdFat instance for the directory that will contain the new directory.
  [in] | path | A path with a valid 8.3 DOS name for the new directory.
  [in] | pFlag | Create missing parent directories if true.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include this file is already open, parent is not a directory, path is invalid or already exists in parent.

bool SdBaseFile::open | ( | SdBaseFile * | dirFile,
|  | uint16_t | index,
|  | uint8_t | oflag
| ) |  |

inherited

Open a file by index.

Parameters

  [in] | dirFile | An open SdFat instance for the directory.
  [in] | index | The index of the directory entry for the file to be opened. The value for index is (directory file position)/32.
  [in] | oflag | Values for oflag are constructed by a bitwise-inclusive OR of flags O_READ, O_WRITE, O_TRUNC, and O_SYNC.

See open() by path for definition of flags.

Returns
  true for success or false for failure.

bool SdBaseFile::open | ( | SdBaseFile * | dirFile,
|  | const char * | path,
|  | uint8_t | oflag
| ) |  |

inherited

Open a file or directory by name.

Parameters

  [in] | dirFile | An open SdFat instance for the directory containing the file to be opened.
  [in] | path | A path with a valid 8.3 DOS name for a file to be opened.
  [in] | oflag | Values for oflag are constructed by a bitwise-inclusive OR of flags from the following list

O_READ - Open for reading.

O_RDONLY - Same as O_READ.

O_WRITE - Open for writing.

O_WRONLY - Same as O_WRITE.

O_RDWR - Open for reading and writing.

O_APPEND - If set, the file offset shall be set to the end of the file prior to each write.

O_AT_END - Set the initial position at the end of the file.

O_CREAT - If the file exists, this flag has no effect except as noted under O_EXCL below. Otherwise, the file shall be created

O_EXCL - If O_CREAT and O_EXCL are set, open() shall fail if the file exists.

O_SYNC - Call sync() after each write. This flag should not be used with write(uint8_t), write_P(PGM_P), writeln_P(PGM_P), or the Arduino Print class. These functions do character at a time writes so sync() will be called after each byte.

O_TRUNC - If the file exists and is a regular file, and the file is successfully opened and is not read only, its length shall be truncated to 0.

WARNING: A given file must not be opened by more than one SdBaseFile object of file corruption may occur.

Note
  Directory files must be opened read only. Write and truncation is not allowed for directory files.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include this file is already open, dirFile is not a directory, path is invalid, the file does not exist or can't be opened in the access mode specified by oflag.

bool SdBaseFile::open | ( | const char * | path,
|  | uint8_t | oflag = `O_READ`
| ) |  |

inherited

Open a file in the current working directory.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for a file to be opened.
  [in] | oflag | Values for oflag are constructed by a bitwise-inclusive OR of open flags. see SdBaseFile::open(SdBaseFile*, const char*, uint8_t).

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool SdBaseFile::openNext | ( | SdBaseFile * | dirFile,
|  | uint8_t | oflag
| ) |  |

inherited

Open the next file or subdirectory in a directory.

Parameters

  [in] | dirFile | An open SdFat instance for the directory containing the file to be opened.
  [in] | oflag | Values for oflag are constructed by a bitwise-inclusive OR of flags O_READ, O_WRITE, O_TRUNC, and O_SYNC.

See open() by path for definition of flags.

Returns
  true for success or false for failure.

bool SdBaseFile::openRoot | ( | SdVolume * | vol | ) |

inherited

Open a volume's root directory.

Parameters

  [in] | vol | The FAT volume containing the root directory to be opened.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include the file is already open, the FAT volume has not been initialized or it a FAT12 volume.

ios::operator const void * | ( |  | ) | const

inlineinherited

Returns
  null pointer if fail() is true.

bool ios::operator! | ( |  | ) | const

inlineinherited

Returns
  true if fail() else false.

int SdBaseFile::peek | ( |  | ) |

inherited

Return the next available byte without consuming it.

Returns
  The byte if no error and not at eof else -1;

int ios_base::precision | ( |  | ) | const

inlineinherited

Returns
  precision

int ios_base::precision | ( | unsigned int | n | ) |

inlineinherited

set precision

Parameters

  [in] | n | new precision

Returns
  old precision

bool SdBaseFile::printCreateDateTime | ( | Print * | pr | ) |

inherited

Print a file's creation date and time

Parameters

  [in] | pr | Print stream for output.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

void SdBaseFile::printFatDate | ( | uint16_t | fatDate | ) |

staticinherited

Print a directory date field to stdOut.

Format is yyyy-mm-dd.

Parameters

  [in] | fatDate | The date field from a directory entry.

void SdBaseFile::printFatDate | ( | Print * | pr,
|  | uint16_t | fatDate
| ) |  |

staticinherited

Print a directory date field.

Format is yyyy-mm-dd.

Parameters

  [in] | pr | Print stream for output.
  [in] | fatDate | The date field from a directory entry.

void SdBaseFile::printFatTime | ( | uint16_t | fatTime | ) |

staticinherited

Print a directory time field to stdOut.

Format is hh:mm:ss.

Parameters

  [in] | fatTime | The time field from a directory entry.

void SdBaseFile::printFatTime | ( | Print * | pr,
|  | uint16_t | fatTime
| ) |  |

staticinherited

Print a directory time field.

Format is hh:mm:ss.

Parameters

  [in] | pr | Print stream for output.
  [in] | fatTime | The time field from a directory entry.

int SdBaseFile::printField | ( | float | value,
|  | char | term,
|  | uint8_t | prec = `2`
| ) |  |

inherited

Print a number followed by a field terminator.

Parameters

  [in] | value | The number to be printed.
  [in] | term | The field terminator. Use '\n' for CR LF.
  [in] | prec | Number of digits after decimal point.

Returns
  The number of bytes written or -1 if an error occurs.

int SdBaseFile::printField | ( | int16_t | value,
|  | char | term
| ) |  |

inherited

Print a number followed by a field terminator.

Parameters

  [in] | value | The number to be printed.
  [in] | term | The field terminator. Use '\n' for CR LF.

Returns
  The number of bytes written or -1 if an error occurs.

int SdBaseFile::printField | ( | uint16_t | value,
|  | char | term
| ) |  |

inherited

Print a number followed by a field terminator.

Parameters

  [in] | value | The number to be printed.
  [in] | term | The field terminator. Use '\n' for CR LF.

Returns
  The number of bytes written or -1 if an error occurs.

int SdBaseFile::printField | ( | int32_t | value,
|  | char | term
| ) |  |

inherited

Print a number followed by a field terminator.

Parameters

  [in] | value | The number to be printed.
  [in] | term | The field terminator. Use '\n' for CR LF.

Returns
  The number of bytes written or -1 if an error occurs.

int SdBaseFile::printField | ( | uint32_t | value,
|  | char | term
| ) |  |

inherited

Print a number followed by a field terminator.

Parameters

  [in] | value | The number to be printed.
  [in] | term | The field terminator. Use '\n' for CR LF.

Returns
  The number of bytes written or -1 if an error occurs.

size_t SdBaseFile::printFileSize | ( | Print * | pr | ) |

inherited

bool SdBaseFile::printModifyDateTime | ( | Print * | pr | ) |

inherited

Print a file's modify date and time

Parameters

  [in] | pr | Print stream for output.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

size_t SdBaseFile::printName | ( |  | ) |

inherited

Print a file's name to stdOut

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

size_t SdBaseFile::printName | ( | Print * | pr | ) |

inherited

Print a file's name

Parameters

  [in] | pr | Print stream for output.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

iostate ios::rdstate | ( |  | ) | const

inlineinherited

Returns
  The iostate flags for this file.

int16_t SdBaseFile::read | ( |  | ) |

inherited

Read the next byte from a file.

Returns
  For success read returns the next byte in the file as an int. If an error occurs or end of file is reached -1 is returned.

int SdBaseFile::read | ( | void * | buf,
|  | size_t | nbyte
| ) |  |

inherited

Read data from a file starting at the current position.

Parameters

  [out] | buf | Pointer to the location that will receive the data.
  [in] | nbyte | Maximum number of bytes to read.

Returns
  For success read() returns the number of bytes read. A value less than nbyte, including zero, will be returned if end of file is reached. If an error occurs, read() returns -1. Possible errors include read() called before a file has been opened, corrupt file system or an I/O error occurred.

int8_t SdBaseFile::readDir | ( | dir_t * | dir | ) |

inherited

Read the next directory entry from a directory file.

Parameters

  [out] | dir | The dir_t struct that will receive the data.

Returns
  For success readDir() returns the number of bytes read. A value of zero will be returned if end of file is reached. If an error occurs, readDir() returns -1. Possible errors include readDir() called before a directory has been opened, this is not a directory file or an I/O error occurred.

bool SdBaseFile::remove | ( | SdBaseFile * | dirFile,
|  | const char * | path
| ) |  |

staticinherited

Remove a file.

The directory entry and all data for the file are deleted.

Parameters

  [in] | dirFile | The directory that contains the file.
  [in] | path | Path for the file to be removed.

Note
  This function should not be used to delete the 8.3 version of a file that has a long name. For example if a file has the long name "New Text Document.txt" you should not delete the 8.3 name "NEWTEX~1.TXT".

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include the file is a directory, is read only, dirFile is not a directory, path is not found or an I/O error occurred.

bool SdBaseFile::remove | ( |  | ) |

inherited

Remove a file.

The directory entry and all data for the file are deleted.

Note
  This function should not be used to delete the 8.3 version of a file that has a long name. For example if a file has the long name "New Text Document.txt" you should not delete the 8.3 name "NEWTEX~1.TXT".

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include the file read-only, is a directory, or an I/O error occurred.

bool SdBaseFile::rename | ( | SdBaseFile * | dirFile,
|  | const char * | newPath
| ) |  |

inherited

Rename a file or subdirectory.

Parameters

  [in] | dirFile | Directory for the new path.
  [in] | newPath | New path name for the file/directory.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include dirFile is not open or is not a directory file, newPath is invalid or already exists, or an I/O error occurs.

void SdBaseFile::rewind | ( |  | ) |

inlineinherited

Set the file's current position to zero.

bool SdBaseFile::rmdir | ( |  | ) |

inherited

Remove a directory file.

The directory file will be removed only if it is empty and is not the root directory. rmdir() follows DOS and Windows and ignores the read-only attribute for the directory.

Note
  This function should not be used to delete the 8.3 version of a directory that has a long name. For example if a directory has the long name "New folder" you should not delete the 8.3 name "NEWFOL~1".

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include the file is not a directory, is the root directory, is not empty, or an I/O error occurred.

bool SdBaseFile::rmRfStar | ( |  | ) |

inherited

Recursively delete a directory and all contained files.

This is like the Unix/Linux 'rm -rf *' if called with the root directory hence the name.

Warning - This will remove all contents of the directory including subdirectories. The directory will then be removed if it is not root. The read-only attribute for files will be ignored.

Note
  This function should not be used to delete the 8.3 version of a directory that has a long name. See remove() and rmdir().

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool SdBaseFile::seekCur | ( | int32_t | offset | ) |

inlineinherited

Set the files position to current position + pos. See seekSet().

Parameters

  [in] | offset | The new position in bytes from the current position.

Returns
  true for success or false for failure.

bool SdBaseFile::seekEnd | ( | int32_t | offset = `0` | ) |

inlineinherited

Set the files position to end-of-file + offset. See seekSet().

Parameters

  [in] | offset | The new position in bytes from end-of-file.

Returns
  true for success or false for failure.

bool SdBaseFile::seekSet | ( | uint32_t | pos | ) |

inherited

Sets a file's position.

Parameters

  [in] | pos | The new position in bytes from the beginning of the file.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

fmtflags ios_base::setf | ( | fmtflags | fl | ) |

inlineinherited

set format flags

Parameters

  [in] | fl | new flags to be or'ed in

Returns
  old flags

fmtflags ios_base::setf | ( | fmtflags | fl,
|  | fmtflags | mask
| ) |  |

inlineinherited

modify format flags

Parameters

  [in] | mask | flags to be removed
  [in] | fl | flags to be set after mask bits have been cleared

Returns
  old flags

void SdBaseFile::setpos | ( | FatPos_t * | pos | ) |

inherited

set position for streams

Parameters

  [out] | pos | struct with value for new position

void ios::setstate | ( | iostate | state | ) |

inlineinherited

Set iostate bits.

Parameters

  [in] | state | Bitts to set.

bool SdBaseFile::sync | ( |  | ) |

inherited

The sync() call causes all modified data and directory fields to be written to the storage device.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include a call to sync() before a file has been opened or an I/O error.

bool SdBaseFile::timestamp | ( | SdBaseFile * | file | ) |

inherited

Copy a file's timestamps

Parameters

  [in] | file | File to copy timestamps from.

Note
  Modify and access timestamps may be overwritten if a date time callback function has been set by dateTimeCallback().

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool SdBaseFile::timestamp | ( | uint8_t | flags,
|  | uint16_t | year,
|  | uint8_t | month,
|  | uint8_t | day,
|  | uint8_t | hour,
|  | uint8_t | minute,
|  | uint8_t | second
| ) |  |

inherited

Set a file's timestamps in its directory entry.

Parameters

  [in] | flags | Values for flags are constructed by a bitwise-inclusive OR of flags from the following list

T_ACCESS - Set the file's last access date.

T_CREATE - Set the file's creation date and time.

T_WRITE - Set the file's last write/modification date and time.

Parameters

  [in] | year | Valid range 1980 - 2107 inclusive.
  [in] | month | Valid range 1 - 12 inclusive.
  [in] | day | Valid range 1 - 31 inclusive.
  [in] | hour | Valid range 0 - 23 inclusive.
  [in] | minute | Valid range 0 - 59 inclusive.
  [in] | second | Valid range 0 - 59 inclusive

Note
  It is possible to set an invalid date since there is no check for the number of days in a month.
  Modify and access timestamps may be overwritten if a date time callback function has been set by dateTimeCallback().

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool SdBaseFile::truncate | ( | uint32_t | length | ) |

inherited

Truncate a file to a specified length. The current file position will be maintained if it is less than or equal to length otherwise it will be set to end of file.

Parameters

  [in] | length | The desired length for the file.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. Reasons for failure include file is read only, file is a directory, length is greater than the current file size or an I/O error occurs.

uint8_t SdBaseFile::type | ( |  | ) | const

inlineinherited

Type of file. You should use isFile() or isDir() instead of type() if possible.

Returns
  The file or directory type.

void ios_base::unsetf | ( | fmtflags | fl | ) |

inlineinherited

clear format flags

Parameters

  [in] | fl | flags to be cleared

Returns
  old flags

SdVolume* SdBaseFile::volume | ( |  | ) | const

inlineinherited

Returns
  SdVolume that contains this file.

unsigned ios_base::width | ( |  | ) |

inlineinherited

Returns
  width

unsigned ios_base::width | ( | unsigned | n | ) |

inlineinherited

set width

Parameters

  [in] | n | new width

Returns
  old width

int SdBaseFile::write | ( | const void * | buf,
|  | size_t | nbyte
| ) |  |

inherited

Write data to an open file.

Note
  Data is moved to the cache but may not be written to the storage device until sync() is called.

Parameters

  [in] | buf | Pointer to the location of the data to be written.
  [in] | nbyte | Number of bytes to write.

Returns
  For success write() returns the number of bytes written, always nbyte. If an error occurs, write() returns -1. Possible errors include write() is called before a file has been opened, write is called for a read-only file, device is full, a corrupt file system or an I/O error.

## Member Data Documentation

const fmtflags ios_base::adjustfield = left | right | internal

staticinherited

mask for adjustfield

const openmode ios_base::app = 0X4

staticinherited

seek to end before each write

const openmode ios_base::ate = 0X8

staticinherited

open and seek to end immediately after opening

const iostate ios_base::badbit = 0X01

staticinherited

iostate bad bit for a nonrecoverable error.

const fmtflags ios_base::basefield = dec | hex | oct

staticinherited

mask for basefield

const openmode ios_base::binary = 0X10

staticinherited

perform input and output in binary mode (as opposed to text mode)

const fmtflags ios_base::boolalpha = 0x0100

staticinherited

use strings true/false for bool

const fmtflags ios_base::dec = 0x0008

staticinherited

base 10 flag

const iostate ios_base::eofbit = 0x02

staticinherited

iostate bit for end of file reached

const iostate ios_base::failbit = 0X04

staticinherited

iostate fail bit for nonfatal error

const iostate ios_base::goodbit = 0x00

staticinherited

iostate for no flags

const fmtflags ios_base::hex = 0x0010

staticinherited

base 16 flag

const openmode ios_base::in = 0X20

staticinherited

open for input

const fmtflags ios_base::internal = 0x0004

staticinherited

fill between sign/base prefix and number

const fmtflags ios_base::left = 0x0001

staticinherited

left adjust fields

const fmtflags ios_base::oct = 0x0020

staticinherited

base 8 flag

const openmode ios_base::out = 0X40

staticinherited

open for output

const fmtflags ios_base::right = 0x0002

staticinherited

right adjust fields

const fmtflags ios_base::showbase = 0x0200

staticinherited

use prefix 0X for hex and 0 for oct

const fmtflags ios_base::showpoint = 0x0400

staticinherited

always show '.' for floating numbers

const fmtflags ios_base::showpos = 0x0800

staticinherited

show + sign for nonnegative numbers

const fmtflags ios_base::skipws = 0x1000

staticinherited

skip initial white space

const openmode ios_base::trunc = 0X80

staticinherited

truncate an existing stream when opening

const fmtflags ios_base::uppercase = 0x4000

staticinherited

use uppercase letters in number representations

bool SdBaseFile::writeError

inherited

writeError is set to true if an error occurs during a write(). Set writeError to false before calling print() and/or write() and check for true after calls to print() and/or write().

The documentation for this class was generated from the following file:

- Arduino/libraries/SdFat/SdStream.h